<?php
/*
 * Weather Information Class
 *
 *
 */
class Weather_information {

  public static $weather_by_zip = "GetCityWeatherByZIP";
  public static $get_weather_images = "GetWeatherInformation";
  public static $url_template = "http://wsf.cdyne.com/WeatherWS/Weather.asmx/%s?%s=%s";

  public static function exists( $zip ){
    $xml = self::get_raw( $zip );
    if ( "true" === (string)$xml->Success ) return true;
    return false;
  }

  private static function get_raw( $zip ){
    $url = sprintf( self::$url_template, self::$weather_by_zip, "ZIP", $zip );
    $response = wp_remote_get( $url );
    $body = wp_remote_retrieve_body( $response );
    $xml = simplexml_load_string( $body );
    return $xml;
  }

  public static function get( $zip ){
    $weather_request = self::get_raw( $zip );

    $weather_object = new stdClass;
    $weather_object->success = (string)$weather_request->Success; /* cast responses as strings */
    $weather_object->response_text = (string)$weather_request->ResponseText;
    $weather_object->state = (string)$weather_request->State;
    $weather_object->city = (string)$weather_request->City;
    $weather_object->weather_station_city = (string)$weather_request->WeatherStationCity;
    $weather_object->weather_id = (string)$weather_request->WeatherID;
    $weather_object->weather_description = (string)$weather_request->Description;
    $weather_object->temperature = (string)$weather_request->Temperature;
    $weather_object->relative_humidity = (string)$weather_request->RelativeHumidity;
    $weather_object->wind = (string)$weather_request->Wind;
    $weather_object->pressure = (string)$weather_request->Pressure;
    $weather_object->image = (string)self::get_image( (int)$weather_object->weather_id );

    return $weather_object;
  }

  public static function get_image( $id ){
    $url = sprintf( self::$url_template, self::$get_weather_images, "ZIP", '', '' );
    $response = wp_remote_get( $url );
    $body = wp_remote_retrieve_body( $response );
    $xml = simplexml_load_string( $body );
    $weather_node = $xml->WeatherDescription[$id];
    return $weather_node->PictureURL;
  }
}